<?php
/**
 * Vegan Cafe Restaurant Theme Customizer.
 *
 * @package Vegan Cafe Restaurant
 */

 if ( ! class_exists( 'Vegan_Cafe_Restaurant_Customizer' ) ) {

	/**
	 * Customizer Loader
	 *
	 * @since 1.0.0
	 */
	class Vegan_Cafe_Restaurant_Customizer {

		/**
		 * Instance
		 *
		 * @access private
		 * @var object
		 */
		private static $vegan_cafe_restaurant_instance;

		/**
		 * Initiator
		 */
		public static function get_instance() {
			if ( ! isset( self::$vegan_cafe_restaurant_instance ) ) {
				self::$vegan_cafe_restaurant_instance = new self;
			}
			return self::$vegan_cafe_restaurant_instance;
		}

		/**
		 * Constructor
		 */
		public function __construct() {
			/**
			 * Customizer
			 */
			add_action( 'customize_preview_init',                  array( $this, 'vegan_cafe_restaurant_customizer_preview_js' ) );
			add_action( 'customize_controls_enqueue_scripts', 	   array( $this, 'vegan_cafe_restaurant_customizer_script' ) );
			add_action( 'customize_register',                      array( $this, 'vegan_cafe_restaurant_customizer_register' ) );
			add_action( 'after_setup_theme',                       array( $this, 'vegan_cafe_restaurant_customizer_settings' ) );
		}
		
		/**
		 * Add postMessage support for site title and description for the Theme Customizer.
		 *
		 * @param WP_Customize_Manager $wp_customize Theme Customizer object.
		 */
		function vegan_cafe_restaurant_customizer_register( $wp_customize ) {
			
			$wp_customize->get_setting( 'blogname' )->transport         = 'postMessage';
			$wp_customize->get_setting( 'blogdescription' )->transport  = 'postMessage';
			$wp_customize->get_setting( 'header_textcolor' )->transport = 'postMessage';
			$wp_customize->get_setting( 'background_color' )->transport = 'postMessage';
			$wp_customize->get_setting('custom_logo')->transport = 'refresh';			
			
			/**
			 * Helper files
			 */
			require VEGAN_CAFE_RESTAURANT_PARENT_INC_DIR . '/customizer/sanitization.php';
		} 
		
		/**
		 * Binds JS handlers to make Theme Customizer preview reload changes asynchronously.
		 */
		function vegan_cafe_restaurant_customizer_preview_js() {
			wp_enqueue_script( 'vegan-cafe-restaurant-customizer', VEGAN_CAFE_RESTAURANT_PARENT_INC_URI . '/customizer/assets/js/customizer-preview.js', array( 'customize-preview' ), '20151215', true );
		}		
		
		function vegan_cafe_restaurant_customizer_script() {
			 wp_enqueue_script( 'vegan-cafe-restaurant-customizer-section', VEGAN_CAFE_RESTAURANT_PARENT_INC_URI .'/customizer/assets/js/customizer-section.js', array("jquery"),'', true  );
		}

		// Include customizer customizer settings.
			
		function vegan_cafe_restaurant_customizer_settings() {
			require VEGAN_CAFE_RESTAURANT_PARENT_INC_DIR . '/customizer/customizer-options/header.php';
			require VEGAN_CAFE_RESTAURANT_PARENT_INC_DIR . '/customizer/customizer-options/frontpage.php';
			require VEGAN_CAFE_RESTAURANT_PARENT_INC_DIR . '/customizer/customizer-options/footer.php';
			require VEGAN_CAFE_RESTAURANT_PARENT_INC_DIR . '/customizer/customizer-options/post.php';
			require VEGAN_CAFE_RESTAURANT_PARENT_INC_DIR . '/customizer/customizer-options/sidebar-option.php';
			require VEGAN_CAFE_RESTAURANT_PARENT_INC_DIR . '/customizer/customizer-options/typography.php';
			require VEGAN_CAFE_RESTAURANT_PARENT_INC_DIR . '/customizer/customizer-options/general.php';
			require VEGAN_CAFE_RESTAURANT_PARENT_INC_DIR . '/customizer/customizer-pro/class-customize.php';
			require VEGAN_CAFE_RESTAURANT_PARENT_INC_DIR . '/customizer/customizer-pro/customizer-upgrade-class.php';
		}

	}
}

/**
 *  Kicking this off by calling 'get_instance()' method
 */
Vegan_Cafe_Restaurant_Customizer::get_instance();